/*
    MON386 - Include file
    Copyright (c) 1994-2003,2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#define BP_CODE   0x00
#define BP_WBYTE  0x01
#define BP_WWORD  0x05
#define BP_WLONG  0x0D
#define BP_RWBYTE 0x03
#define BP_RWWORD 0x07
#define BP_RWLONG 0x0F

typedef union {
    struct long_regs {
        long        lEAX;
        long        lEBX;
        long        lECX;
        long        lEDX;
        long        lESI;
        long        lEDI;
        long        lEBP;
        long        lESP;
    } lr;
    struct word_regs {
        unsigned    wAX, wAXH;
        unsigned    wBX, wBXH;
        unsigned    wCX, wCXH;
        unsigned    wDX, wDXH;
        unsigned    wSI, wSIH;
        unsigned    wDI, wDIH;
        unsigned    wBP, wBPH;
        unsigned    wSP, wSPH;
        unsigned    wSS;
        unsigned    wDS;
        unsigned    wES;
        unsigned    wFS;
        unsigned    wGS;
        unsigned    wIP;
        unsigned    wCS;
        unsigned    wFLAGS;
        unsigned    wEFLAGS;
    } wr;
    struct {
        unsigned char   bAL, bAH, bA1, bA2;
        unsigned char   bBL, bBH, bB1, bB2;
        unsigned char   bCL, bCH, bC1, bC2;
        unsigned char   bDL, bDH, bD1, bD2;
    } br;
} MON3REGS;

typedef struct {
    unsigned    wFlags;
    unsigned    wVSeg;
    long        lVOfs;
    unsigned    wCOfs;
    unsigned    wCSeg;
    char far    *pszLine;
    unsigned    wListSize;
    char        bReserved[16];
} D3CONTROL;

int far pascal mon3_init( void far *, void far * );
int far pascal mon3_done( void );
int far pascal mon3_setbreakpoint( void far *, int, int );
int far pascal mon3_clearbreakpoint( int );
int far pascal mon3_setsinglestep( void );
int far pascal mon3_clearsinglestep( void );

int far pascal dis3_decode( D3CONTROL far * );
