/*
    MON386 - Test program
    Copyright (c) 1994-2003,2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "mon386.h"

#define STACKSIZE   4096

static  D3CONTROL   d3Control;
static  char        baStackFrame[STACKSIZE];
static  char        szLine[80];

void dummy( void )
{
    asm {
        mov     ax, 1
        add     ax, 2
        inc     cx
        sub     ax, cx
        dec     dx
    }
}

void far pascal breakhandler( int iBreakpoint, MON3REGS far *pReg )
{
    d3Control.wFlags = 0;
    d3Control.wVSeg = pReg->wr.wCS;
    d3Control.lVOfs = pReg->wr.wIP;
    d3Control.wCSeg = pReg->wr.wCS;
    d3Control.wCOfs = pReg->wr.wIP;
    d3Control.wListSize = 23;
    d3Control.pszLine = (char far *)szLine;

    dis3_decode( &d3Control );
    printf( "%s\n", szLine );

    mon3_setsinglestep();
    switch( getch() ) {
        case 'g':
        case 'G':
            mon3_clearsinglestep();
            break;
    }
}

void main( void )
{
    if( mon3_init( breakhandler, &baStackFrame[STACKSIZE-2] ) != 0 ) {
        printf( "Unable to initialize MON386.\n" );
        exit( 0 );
    }
    mon3_setbreakpoint( &dummy, 2, BP_CODE );
    dummy();
    mon3_done();
}
