;------------------------------------------------------------
;
; Registers structure
;
REGISTERS       STRUC
        rEAX    DD      ?               ; General registers
        rEBX    DD      ?
        rECX    DD      ?
        rEDX    DD      ?
        rESI    DD      ?
        rEDI    DD      ?
        rEBP    DD      ?
        rESP    DD      ?               ; SS:ESP
        rSS     DW      ?
        rDS     DW      ?               ; Segment registers
        rES     DW      ?
        rFS     DW      ?
        rGS     DW      ?
        rIP     DW      ?               ; CS:IP
        rCS     DW      ?
        rFLAGS  DW      ?               ; Flags
        rEFLAGS DW      ?               ; High word of extended flags
REGISTERS       ENDS

; 16-bit registers
REGS16          STRUC
        wAX     DW      ?, ?
        wBX     DW      ?, ?
        wCX     DW      ?, ?
        wDX     DW      ?, ?
        wSI     DW      ?, ?
        wDI     DW      ?, ?
        wBP     DW      ?, ?
        wSP     DW      ?, ?
REGS16          ENDS

; 8-bit registers
REGS8           STRUC
        bAL     DB      ?
        bAH     DB      ?, ?, ?
        bBL     DB      ?
        bBH     DB      ?, ?, ?
        bCL     DB      ?
        bCH     DB      ?, ?, ?
        bDL     DB      ?
        bDH     DB      ?, ?, ?
REGS8           ENDS

;------------------------------------------------------------
;
; Flags
;
FLAGS   RECORD  f1:1,           \
                fNT:1,          \               ; Nested task
                fIOPL:2,        \               ; I/O privilege level
                fOVERFLOW:1,    \               ; Overflow
                fDIRECTION:1,   \               ; Direction
                fINT:1,         \               ; Interrupt enable
                fTRAP:1,        \               ; Trap
                fSIGN:1,        \               ; Sign
                fZERO:1,        \               ; Zero
                f2:1,           \
                fAUXCARRY:1,    \               ; Auxiliary carry
                f3:1,           \
                fPARITY:1,      \               ; Parity
                f4:1,           \
                fCARRY:1                        ; Carry
